#include "gd32f10x.h"
#include "fmc.h"


/*-------------------------------------------------*/
/*FLASH     һ1KB3*1024 */
/*  startʼҳ   numҳ    */
/*ֵ                                       */
/*
flashṹ
0x08000000~0x0807FFFF   bank02KBһҳ0~255ҳ256ҳ512KB
0x08080000~0x082FFFFF   bank14KBһҳ256~895ҳ640ҳ2.5MB
*/
/*-------------------------------------------------*/
void GD32_EraseFlash(uint16_t start, uint16_t num)
{
	uint16_t i;        //forѭ
	uint16_t j = 0;        

	fmc_unlock();                                                       //
	if ((start < 256) && ((start + num) < 256))
	{
		for(i = 0; i < num; i++)										//ѭnumΣһҳһҳĲ
		{
			fmc_page_erase((0x08000000 + start * 2048) + (2048 * i));   //bank0һҳ2KB
		}
	}
	else if ((start < 256) && ((start + num) > 256))
	{
		for(i = 0; i < num; i++)										//ѭnumΣһҳһҳĲ
		{
			if((start + i) < 256)
			{
				fmc_page_erase((0x08000000 + start * 2 * 1024) + (2 * 1024 * i));       //bank0һҳ2KB
			}
			else
			{
				fmc_page_erase(0x08080000 + (4 * 1024 * j));       //bank1һҳ4KB
				j++;
			}
		}
	}
	else if (start > 256)
	{
		for(i = 0; i < num; i++)										//ѭnumΣһҳһҳĲ
		{
			fmc_page_erase((0x08080000 + (start - 256) * 4 * 1024) + (4 * 1024 * i));   //bank1һҳ4KB
		}
	}
	
	fmc_lock();                                                         //
} 
/*---------------------------------------------------------------------*/
/*дFLASH                                                    */
/*  saddrдַ wdataдָ  wnumдٸֽ    */
/*ֵ                                                           */
/*---------------------------------------------------------------------*/
void GD32_WriteFlash(uint32_t saddr, uint32_t *wdata, uint32_t wnum)
{
	fmc_unlock();                          //
	while(wnum){                           //ѭд룬֪num0˳whileʾд
		fmc_word_program(saddr,*wdata);    //дһ֣4ֽڣ
		wnum-=4;                           //дֽ-4
		saddr+=4;                          //дַ+4
		wdata++;                           //дݵָ룬Ųһ
	}
	fmc_lock();                            //
}

